import {createContext} from "react";
import {io} from "socket.io-client";

export const SocketContext = createContext({});

export const SocketProvider = ({ children }) => {
    const socket = io("/", {autoConnect: false});

    const connect = () => {
        socket.connect();
    }

    const send = (event, data) => {
        socket.emit(event, data);
    }

    const disconnect = () => {
        socket.disconnect();
    }

    const addListener = (event, callback) => {
        socket.on(event, callback);
    }

    return (
        <SocketContext.Provider value={{connect, disconnect, send, addListener}}>
            {children}
        </SocketContext.Provider>
    )
}